Summary:        Database independent interface for Perl
Name:           perl-DBI
Version:        1.643
Release:        7%{?dist}
License:        GPL+ or Artistic
URL:            http://dbi.perl.org/
Source0:        https://cpan.metacpan.org/authors/id/T/TI/TIMB/DBI-%{version}.tar.gz
BuildRequires:  gcc make
BuildRequires:  glibc-common coreutils findutils sed
BuildRequires:  perl-interpreter perl-generators perl-devel
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Find) perl(strict)
BuildRequires:  perl(base) perl(constant) perl(Carp) perl(Config)
BuildRequires:  perl(Cwd) perl(Data::Dumper) perl(DynaLoader) perl(Errno)
BuildRequires:  perl(Exporter) perl(Fcntl) perl(FileHandle) perl(File::Basename)
BuildRequires:  perl(File::Spec) perl(Getopt::Long)
BuildRequires:  perl(IO::Dir) perl(IO::File) perl(IO::Select) perl(IPC::Open3)
BuildRequires:  perl(Math::BigInt) perl(Scalar::Util) perl(Storable)
BuildRequires:  perl(Symbol) perl(threads) perl(Tie::Hash)
BuildRequires:  perl(UNIVERSAL) perl(utf8) perl(vars) perl(warnings)
# Tests
BuildRequires:  perl(blib) perl(B) perl(Benchmark) perl(Encode)
BuildRequires:  perl(File::Copy) perl(File::Path) perl(lib) perl(overload)
BuildRequires:  perl(Test::More) perl(Test::Simple) >= 0.90

Requires:       perl(FileHandle) perl(Math::BigInt)
%{?perl_default_filter}
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\(RPC::\\)

%description 
The DBI is the standard database interface module for Perl.
It defines a set of methods, variables and conventions that provide
a consistent database interface independent of the actual database being used.


%prep
%setup -q -n DBI-%{version} 
for file in lib/DBD/Gofer.pm; do
    iconv -f ISO-8859-1 -t UTF-8 < "${file}" > "${file}.utf8"
    touch -r "${file}" "${file}.utf8"
    mv "${file}.utf8" "${file}"
done
# Fix shellbangs
for file in dbixs_rev.pl ex/corogofer.pl; do
    perl -MExtUtils::MakeMaker -e "ExtUtils::MM_Unix->fixin(q{$file})"
done

chmod 0644 ex/*
chmod 0755 dbixs_rev.pl
# remove coro
rm lib/DBD/Gofer/Transport/corostream.pm
sed -i -e '/^lib\/DBD\/Gofer\/Transport\/corostream.pm$/d' MANIFEST
# CVE-2013-7284
for file in lib/Bundle/DBI.pm lib/DBD/Proxy.pm lib/DBI/ProxyServer.pm dbiproxy.PL t/80proxy.t; do
    rm "${file}"
    sed -i -e '\|^'"${file}"'|d' MANIFEST
done
sed -i -e 's/"dbiproxy$ext_pl",//' Makefile.PL

# Remove Win32 to avoid unwanted dependencies
for file in lib/DBI/W32ODBC.pm lib/Win32/DBIODBC.pm; do
    rm "${file}"
    sed -i -e '\|^'"${file}"'|d' MANIFEST
done


%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}" NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}


%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} '%{buildroot}'/*


%check
make test


%files
%license LICENSE
%doc README.md ex/perl_dbi_nulls_test.pl ex/profile.pl
%{_bindir}/dbipro*
%{_bindir}/dbilogstrip
%{perl_vendorarch}/*.p*
%{perl_vendorarch}/DBD/
%{perl_vendorarch}/DBI/
%{perl_vendorarch}/auto/DBI/
%{_mandir}/man1/*.1*
%{_mandir}/man3/*.3*


%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.643-7
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.643-6
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.643-5
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 15 2023 Xiaojie Chen <jackxjchen@tencent.com> - 1.643-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.643-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.643-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Aug 02 2022 rockerzhu <rockerzhu@tencent.com> - 1.643-1
- Initial build
